
#ifndef _IDENT_AUTH_H
#define _IDENT_AUTH_H

#define IDENT_BUFFER_SIZE 4096

#ifndef IDENT_INT16
#define IDENT_INT16 unsigned short 
#endif
#define MUTUAL_AUTH_BIT 0x01 

#ifdef TESTING 
/* For testing , should be "ident" for real */ 
#define IDENT_AUTH_KRB_SERVICE "rcmd" 
#else 
#define IDENT_AUTH_KRB_SERVICE "ident"
#endif  
#define IDENT_READ_TIMEOUT 60

/* stolen from sendmail */ 
#ifndef ARBPTR_T
# define ARBPTR_T       void *
#endif


/* 
 * 
 * Structs for ident authentication 
 * 
 */ 
struct ident_responder_auth {
    char *auth_method;		/* Name of authentication mechanism */
    int (*start)();		/* Start a responder->requester authentication */
    int (*auth)();		/* Do an authentication protocol exchange */
    void (*free_state)();	/* Free an authentication state */
};

struct ident_auth_data {
  FILE *fp ; /* input stream */ 
  char *port_data ; /* points to port data part of auth_line */ 
  char *cmd_data  ; /* points to "cmd" (i.e. AUTHENTICATE) part of line */ 
  char *authenticate_data ; /* points to AUTHENTICATE part of line */ 
  int uid; /* Uid of process */ 
  int pid; /* Pid of process */ 
  struct ident_responder_auth *auth_struct ; /* Pointer to auth_methods */ 
  int local_port ; /* Local port of connection */ 
  int remote_port ; /* Remote port of connection */ 
  
  struct in_addr *local_addr ; /* IP address local */  
  struct in_addr *remote_addr ; /* IP address remote */ 
  ARBPTR_T auth_method_data  ; /* Ptr to arbitrary struct needed for auth _method */ 

};


#endif
