/** @file
 * Common variables for the S/Ident daemon.
 *
 * This program is in the public domain and may be used freely by anyone who
 * wants to.
 *
 * @author Peter Eriksson <pen@lysator.liu.se>
 * @author with S/Ident modifications by Booker C. Bense <bbense@stanford.edu>
 *
 * $Id: identd.h,v 1.2 2002/10/29 00:52:15 eagle Exp $
 */

#ifndef IDENTD_H
#define IDENTD_H

extern char version[];

extern char *path_unix;
extern char *path_kmem;

extern int verbose_flag;
extern int debug_flag;
extern int syslog_flag;
extern int multi_flag;
extern int other_flag;
extern int unknown_flag;
extern int uidonly_flag; 
extern int users_can_nosident;
extern int crypto_flag;
extern int allow_trivial; 
extern int mutual_auth_flag; 
extern int client_only_flag; 

extern char *charset_name;
extern char *indirect_host;
extern char *indirect_password;

extern int lport;
extern int fport;

extern char *gethost();

extern int k_open();
extern int k_getuid();
extern int parse();
extern int parse_config();

#include "sident.h" 

#define MAX_PORT  65535
#define VALID_PORT( _port_ ) ((_port_) > 1 && (_port_) < MAX_PORT )

/* You may want to change this for whatever makes sense at your site. */ 

#define SERVER_PORT( _port_) ((_port_) < 1024 && (_port_) != 6000 )

#include "config.h" 

/* lstat defines */ 

#ifndef S_IRUSR
#define S_IRUSR  0000400 
#endif
#ifndef S_IRGRP
#define S_IRGRP  0000040 
#endif
#ifndef S_IWGRP
#define S_IWGRP  0000020 
#endif
#ifndef S_IROTH
#define S_IROTH  0000004 
#endif
#ifndef S_IWOTH
#define S_IWOTH  0000002 
#endif

#endif /* !IDENTD_H */
